<?php
/**
 * @version 1.0.1
 * @package Joomla 1.5
 * @subpackage Content Restriction
 * @copyright	Copyright (C) 2011 webconstruction.ch. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt
 * @contact		info@webconstruction.ch
 * @website		www.webconstruction.ch
 * This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.
 */


defined('_JEXEC') or die ('Access denied!');

jimport('joomla.plugin.plugin');

$AccessContentdebugId = 0; 
global $AccessContentdebugId; 
$AccessContentdebugId = 0; 

class plgContentContentRestriction extends JPlugin
{
    //Constructor
    function plgContentContentRestriction( & $subject, $config)
    {
        parent::__construct( $subject, $config);
    }
    
    var $canbeEdited = false;

    function getUserGroup($id=0){
    	if ($id>0){
	    	$user   = &JFactory::getUser($id);
    	}else{
	    	$user   = &JFactory::getUser();
    	}
		if ($user->guest){
			return 'Public';
		}
		return $user->usertype;
    }
    
    function canEdit($id=0){
    	$group = $this->getUserGroup($id);
    	if ($group=='Public'||$group=='Registered')return false;
    	return true;
    }
    
    function onPrepareContent(& $article, & $params, $limitstart)
    {	
    	$mainframe =& JFactory::getApplication();
	    if ($mainframe->isAdmin()){
    		return;
    	}
		if($this->canEdit()){
    		$this->canbeEdited = true;
    	}
    	$this->articleId=$article->id;
    	$content = $article->text;
        if (strpos('@'.$content,'{access')==0)return;
        $content = str_replace('{access}','{access  }',$content);
    	$content = $this->renderContentAccess($content);
	    $article->text = $content;
    }
    
    function renderContentAccess($content){
    	$content = $this->stripPTags($content);
    	preg_match_all("#{access[\s]*(.*?)}(.*?){/access}#s", $content, $matches);
		$db     = &JFactory::getDBO();
		$user   = &JFactory::getUser();
		$group = $this->getUserGroup();
		$groups = array($group=>0);
		$defaultParam = trim($this->params->get('defaultParams',''));
		if (substr($defaultParam,0,1)!=','){
			$defaultParam = ','.$defaultParam;
		}
    	for ($i=0;$i<count($matches[0]);$i++){
	    	$match = $this->checkGroupMatch($matches[1][$i].$defaultParam,$groups);
	    	$debugstr = '';
	    	$debugstrEnd = '';
	    	if ($this->debugGroup){
	    		$debugstr = $this->debug($matches[1][$i].$defaultParam);
	    		$debugstrEnd = '</div>';
	    	}
	    	if (!$match){
	    		$content = $this->_str_replaceFirst($matches[0][$i],$debugstr.$debugstrEnd,$content);
	    	}else{
	    		$content = $this->_str_replaceFirst($matches[0][$i],$debugstr.$matches[2][$i].$debugstrEnd,$content);
	    	}
	    }
	    return $content;
    }

    
    function debug_getUsersByGroup($group){
	    //$userIds = JAccess::getUsersByGroup($groupId);
		$db =& JFactory::getDBO();
		$db->setQuery("SELECT `id` FROM `#__users` WHERE `usertype`=".$db->Quote($group)).' LIMIT 100;';
		$userIds = $db->loadResultArray();
		$tmpArray = array();
	    for ($i=0;$i<count($userIds);$i++){
			$user = JFactory::getUser($userIds[$i]);
	    	$tmpArray[] = $user->name;
	    }
	    return $tmpArray;
    }
    
    var $articleId;
	var $usersCanedit = null;
    
    function debug_getUsersCanedit(){
    	if (is_array($this->usersCanedit))return $this->usersCanedit;
    	$db =& JFactory::getDBO();
		$db->setQuery("SELECT `id` FROM `#__users`");
		$allusers = $db->loadResultArray();
		$retArray = array();
		for ($i=0;$i<count($allusers);$i++){
			$user = JFactory::getUser($allusers[$i]);
			if ($this->canEdit(intval($allusers[$i]))){
				$retArray[] = $user->name;
			}
		}
		return $retArray;
    }
    
    var $debugGroup =false;


    function debug($tagGroups){
    	global $AccessContentdebugId;
    	$AccessContentdebugId++;
    	$ret = '<div style="border:solid 1px #000" id="accessContentDebugId_'.$AccessContentdebugId.'"><p><strong>Debug Mode:</strong> <button onclick="document.getElementById(\'accessContentDebugId_'.$AccessContentdebugId.'\').style.display=\'none\';document.getElementById(\'accessContentDebugIdObject_'.$AccessContentdebugId.'\').style.border=\'none\';">hide this debug</button><br />';
    	/*$db =& JFactory::getDBO();
		$db->setQuery("SELECT `id`,`title` FROM `#__usergroups`");
		$allUserGroups = $db->loadAssocList();*/
    	$allUserGroups = array(
    			array('title'=>'Public'),
    			array('title'=>'Registered'),
	   			array('title'=>'Editor'),
      			array('title'=>'Author'),
      			array('title'=>'Publisher'),
      			array('title'=>'Manager'),
    			array('title'=>'Administrator'),
    			array('title'=>'Super Administrator')
    	);
		
		$matches = 0;
		$accessSubId = 0;
		$users = array();
		for ($i=0;$i<count($allUserGroups);$i++){
			$match = $this->checkGroupMatch($tagGroups,array($allUserGroups[$i]['title']=>'1'),true);
			if ($match){
				$matches++;
				$ret .= "<strong>Access</strong> for user group <strong>".$allUserGroups[$i]['title']."</strong>.";
				if (intval($this->params->get('showUsers',1))==1){
					$users = $this->debug_getUsersByGroup($allUserGroups[$i]['title']);
				}
				if (count($users)>0&&intval($this->params->get('showUsers',1))==1){
					$accessSubId++;
					$ret .= '<button onclick="document.getElementById(\'accessContentDebugIdSub_'.$AccessContentdebugId.'_'.$accessSubId.'\').style.display = \'block\';">Show Users ('.count($users).')</button><div style="display:none" id="accessContentDebugIdSub_'.$AccessContentdebugId.'_'.$accessSubId.'">'.implode(',',$users).'</div>';
				}else if (intval($this->params->get('showUsers',1))==1){
					$ret .= ' 0 users';
				}
				$ret .= '<br />';
			}/*else{
				$ret .= "<strong>No</strong> access for ".$allUserGroups[$i]."<br />";
			}*/
		}
		$match = $this->checkGroupMatch($tagGroups,array('canedit'=>'1'),true);
		if ($this->canEditMatch){
			$matches++;
			$ret .= "<strong>Access</strong> for all users / user groups, which can <strong>edit</strong> this article.";
			if (intval($this->params->get('showUsers',1))==1){
				$users = $this->debug_getUsersCanedit();
			}
			if (count($users)>0&&intval($this->params->get('showUsers',1))==1){
				$accessSubId++;
				$ret .= '<button onclick="document.getElementById(\'accessContentDebugIdSub_'.$AccessContentdebugId.'_'.$accessSubId.'\').style.display = \'block\';">Show Users ('.count($users).')</button><div style="display:none" id="accessContentDebugIdSub_'.$AccessContentdebugId.'_'.$accessSubId.'">'.implode(',',$users).'</div>';
			}else if (intval($this->params->get('showUsers',1))==1){
				$ret .= ' 0 users';
			}
			$ret .= '<br />';
		}
		if ($matches==0){
			$ret .= 'No access for any user group.<br />';
		}
		$ret .= '</p></div><div style="border:red 1px solid;" id="accessContentDebugIdObject_'.$AccessContentdebugId.'">';
		//$ret .= '<p>(Note: Canedit user groups can not [yet] be detected in the debugging.)</p></div>';
		return $ret;
    }
    
    var $canEditMatch=false;
    
    function checkGroupMatch($tagGroups,$groups,$debug=false){
    	$tagGroups = explode(',',$tagGroups);
    	$totalMustMatch = 0;
    	$orMustMatch = 0;
    	$match=0;
    	$this->debugGroup = false;
    	if ($this->canbeEdited&&$debug==false){
    		$groups['Canedit']=1;
    	}
    	foreach ($tagGroups as $tagGroup){
	   		$tagGroup = strtolower(trim($tagGroup));
    		if ($tagGroup=='')continue;
	   		reset($groups);
    		$tmpmatch = false;
	   		$oldTagGroup = $tagGroup;
    		$tmpMustMatch = 0;
	   		foreach ($groups as $group => $groupId){
	   			$tagGroup = $oldTagGroup;
    			$group = strtolower($group);
    			$hasMatch = false;
			    if (substr($tagGroup,0,2)=='+#'){
			    	$tmpMustMatch=1;
			    	$tagGroup = trim(substr($tagGroup,2));
			    	if (preg_match('#'.$tagGroup.'#i',$group)){
			    		$tmpmatch=true;
			    		$hasMatch = true;
			    	}
			    }else if (substr($tagGroup,0,3)=='+!#'){
			    	$tmpMustMatch=1;
			    	$tagGroup = trim(substr($tagGroup,3));
			    	if (!preg_match('#'.$tagGroup.'#i',$group)){
			    		$tmpmatch=true;
			    	}
			    }else if (substr($tagGroup,0,1)=='+'){
			    	$tmpMustMatch=1;
			    	$tagGroup = trim(substr($tagGroup,1));
			    	if ($tagGroup==$group){
			    		$tmpmatch=true;
			    		$hasMatch = true;
			    	}
			    }else if (substr($tagGroup,0,2)=='!#'){
					$orMustMatch = 1;
			    	$tagGroup = trim(substr($tagGroup,2));
			    	if (!preg_match('#'.$tagGroup.'#i',$group)){
			    		$tmpmatch=true;
			    	}
			    }else if (substr($tagGroup,0,1)=='#'){
			    	$orMustMatch = 1;
			    	$tagGroup = trim(substr($tagGroup,1));
			    	if (preg_match('#'.$tagGroup.'#i',$group)){
			    		$tmpmatch=true;
			    		$hasMatch = true;
			    	}
			    }else if (substr($tagGroup,0,1)=='!'){
					$orMustMatch = 1;
			    	$tagGroup = trim(substr($tagGroup,1));
					if (trim($tagGroup)!=$group){
			    		$tmpmatch=true;
			    	}
			    }else if (substr($tagGroup,0,7)=='debug=#'){
			    	$tagGroup = trim(substr($tagGroup,7));
			    	if (preg_match('#'.$tagGroup.'#i',$group)){
				    	$this->debugGroup = true;
			    	}
			    }else if (substr($tagGroup,0,8)=='debug =#'){
			    	$tagGroup = trim(substr($tagGroup,8));
			    	if (preg_match('#'.$tagGroup.'#i',$group)){
				    	$this->debugGroup = true;
			    	}
			    }else if (substr($tagGroup,0,6)=='debug='){
			    	$tagGroup = trim(substr($tagGroup,6));
			    	if ($tagGroup==$group){
				    	$this->debugGroup = true;
			    	}
			    }else if (substr($tagGroup,0,7)=='debug ='){
			    	$tagGroup = trim(substr($tagGroup,7));
			    	if ($tagGroup==$group){
				    	$this->debugGroup = true;
			    	}	
			    }else{
					$orMustMatch = 1;
					if (trim($tagGroup)==$group){
						$tmpmatch=true;
			    		$hasMatch = true;
			    	}
			    }
			    if ($group=='canedit'&&$hasMatch==true&&$debug==true){
			    	$this->canEditMatch=true;
			    }
    		}
    		if ($tmpmatch){
    			$match++;
    		}
    		$totalMustMatch+=$tmpMustMatch;
    	}
    	$totalMustMatch+=$orMustMatch;
    	if ($match>=$totalMustMatch)return true;
    	return false;
    }
    
    function stripPTags($content){
    	//strip <p> tags
		$content = str_replace('<p>{access','{access',$content);
    	$content = str_replace('<p>{/access','{/access',$content);
    	$content = str_replace('{/access}</p>','{/access}',$content);
    	preg_match_all("#{access(.*?)</p>#s",$content,$matches2);
    	for($i=0;$i<count($matches2[1]);$i++){
    		if (!(stripos('@'.$matches2[1][$i],'<p>')>0)){
    			$match2 = $this->_str_replaceFirst('</p>','',$matches2[0][$i]);
    			$content = $this->_str_replaceFirst($matches2[0][$i],$match2,$content);
    		}
    	}
    	return $content;
    }
    
	function _str_replaceFirst($s, $r, $str)
    {
        $l = strlen($str);
        $a = strpos($str, $s);
        $b = $a+strlen($s);
        $temp = substr($str, 0, $a).$r.substr($str, $b, ($l-$b));
        return $temp;
    }
}
