<?php
defined('_JEXEC') or die;

require_once dirname(__FILE__) . str_replace('/', DIRECTORY_SEPARATOR, '/../../../functions.php');

// Create component view for Joomla! 1.5 or 1.6.
// The classes are defined in ../../../functions.php file and encapsulate 
// version-specific queries and formatting.
$version = new JVersion();
if ($version->RELEASE == '1.5') {
    $component = new ArtxContent15($this, $this->params);
    $article = $component->article($this->article, $this->print);
} else {
    $component = new ArtxContent16($this, $this->params);
    $article = $component->article($this->item, $this->print);
    JHtml::addIncludePath(JPATH_COMPONENT . DS . 'helpers');
}


echo $component->beginPageContainer('item-page');
if ($component->showPageHeading && $article->title != $component->pageHeading)
    echo $component->pageHeading();
$params = $article->getArticleViewParameters();
if ($article->titleVisible) {
    $params['header-text'] = $this->escape($article->title);
    if (strlen($article->titleLink))
        $params['header-link'] = $article->titleLink;
}
// Build article content
$content = '';
if (!$article->showIntro)
    $content .= $article->event('afterDisplayTitle');
$content .= $article->event('beforeDisplayContent');
$content .= $article->toc();
if ($article->showText)
    $content .= $article->content();
else if ($article->showTeaser) {
    $content .= $article->introText();
    if ($this->showReadmore)
        $content .= $article->readmore();
}
$content .= $article->event('afterDisplayContent');
$params['content'] = $content;
// Change the order of "if" statements to change the order of article metadata footer items.
if ($article->showParentCategory || $article->showCategory)
  $params['metadata-footer-icons'][] = $article->categories();
// Render article
echo $article->article($params);
echo $component->endPageContainer();
